from zipfile import ZipFile
import os
from os.path import basename
from glob import glob
import shutil

def compress_results_files():

    # Name of the Directory to be zipped
    dirName = 'Figures'

    # create a ZipFile object
    with ZipFile('results.zip', 'w') as zipObj:
        zipObj.write('output_file.txt')
        # Iterate over all the files in directory
        for folderName, subfolders, filenames in os.walk(dirName):
            for filename in filenames:
                #create complete filepath of file in directory
                filePath = os.path.join(folderName, filename)
                # Add file to zip
                zipObj.write(filePath)

    # Delete multiple files (uploaded or created)
    patterns = ('*.obj', '*.dll', '*.exe', '*.manifest', '*.pch', '*.lib', '*.rsp', 'Makefile', '*.txt', '*.pdf', '*.doc', '*.docx', '*.xlsx', '*.lp')
    for p in patterns:
        for f in glob(p):
            os.remove(f)  
    
    # Delete Figures directory 
    for root, dirs, files in os.walk(dirName, topdown=False):
        for name in files:
            os.remove(os.path.join(root, name))
        for name in dirs:
            os.rmdir(os.path.join(root, name))