""""
========================== Plotting Results =========================
"""
import os
import matplotlib.pyplot as plt 
import numpy as np

class PlottingResults: 
	def __init__(self, data, results):
		self.data = data
		self.results = results

	# Function to write results in an txt file
	def CreatingFigures (self):
		data = self.data
		results = self.results
		# Creating a list with the number of hours only for graphics purposes!
		hours = list(map(int, data.T))

		# Creating figures per contingency and per scenario. 
		for s in data.S:
			folder = "Figures_Scen_" + str(s) + "/"
			figures_dir = os.path.join('Figures/',folder)
			if not os.path.isdir(figures_dir):
				os.makedirs(figures_dir)
			
			for c in data.C:
			# Creating aux_list for each scenario
				aux_list = [(results.PEDS[t][s][c], sum([data.fPV[t][s] * data.eta[a] * results.MxPPV_alpha_xPV[a][t][s][c] for a in data.A]), abs(results.PTER[t][s][c]), (results.PESS_in[t][s] - results.PESS_out[t][s]), data.fD[t][s] * data.MxPD) for t in data.T]
				aux_list = np.array(aux_list)
				plt.figure(c+s)
				plt.bar(range(len(data.T)),aux_list[:,0],color='blue',label="SUB")
				plt.legend()
				plt.bar(range(len(data.T)),aux_list[:,1],color='red',label="PV")
				plt.legend()
				plt.bar(range(len(data.T)), aux_list[:,2], bottom=aux_list[:,0]+aux_list[:,1], color='yellow',label="Thermal")
				plt.legend()
				plt.bar(range(len(data.T)), aux_list[:,3],color="black",label="ESS operation")
				plt.legend()
				plt.plot(range(len(data.T)), aux_list[:,4],'-o', color="black", linewidth=2, label="Demand")
				plt.legend()
				plt.xlabel('Time[h]')
				plt.ylabel('Active power [kW]')
				#plt.xticks(np.arange(min(hours)-1, max(hours), 4.0),range(0,100,2))

				# Saving figures in a specific folder in the current path 
				plt.savefig(figures_dir +"Fig_C" + str(c)+"_S" + str(s) + ".png")

				# Cleaning aux_list to move to the next scenario
				aux_list = []
				plt.close(plt.figure(c+s))

