""""
========================== Plotting Results =========================
"""
import os
import matplotlib.pyplot as plt 
import numpy as np
from datetime import datetime, timedelta
import matplotlib.dates as mdates


class PlottingResults: 
	def __init__(self, data, results):
		self.data = data
		self.results = results
		

	# Function to write results in an txt file
	def CreatingFigures (self, path):
		data = self.data
		results = self.results
		# Creating a list with the number of hours only for graphics purposes!
		hours = list(map(int, data.T))

		# Creating figures per contingency and per scenario. 
		for s in data.S:
			folder = "Figures_Scen_" + str(s) + str(path) + "/"
			figures_dir = os.path.join('Figures/',folder)
			if not os.path.isdir(figures_dir):
				os.makedirs(figures_dir)
			xaxis = []
			for t in data.T:
				xaxis.append(int(t) * data.deltat)
			
			
			for c in data.C:
			# Creating aux_list for each scenario
				aux_list = [(results.PEDS[t][s][c], sum([data.fPV[t][s] * data.eta[a] * results.MxPPV_alpha_xPV[a][t][s][c] for a in data.A]), abs(results.PTER[t][s][c]), (results.PESS_in[t][s][c] - results.PESS_out[t][s][c]), data.fD[t][s] * data.MxPD) for t in data.T]
				aux_list = np.array(aux_list)
				plt.figure(c+s, figsize=(8, 3))
				plt.bar(xaxis,aux_list[:,0],color='blue',label="SUB", width=0.35)
				plt.legend()
				plt.bar(xaxis,aux_list[:,1],color='red',label="PV", width=0.35)
				plt.legend()
				plt.bar(xaxis, aux_list[:,2], bottom=aux_list[:,0]+aux_list[:,1], color='yellow',label="Thermal", width=0.35)
				plt.legend()
				plt.bar(xaxis, aux_list[:,3],color="black",label="ESS operation", width=0.35)
				plt.legend()
				plt.plot(xaxis, aux_list[:,4],'-o', color="black", linewidth=2, label="Demand")
				plt.legend()
				plt.xlabel('Time[h]')
				plt.ylabel('Active power [kW]')
				plt.ylim(-600, 1000)
				plt.xlim(0.5, 24.5)
				plt.tight_layout()

				#plt.xticks(np.arange(min(hours)-1, max(hours), 4.0),range(0,100,2))

				# Rotacionar os rótulos do eixo x para melhor visualização
				plt.xticks(rotation=45)

				# Saving figures in a specific folder in the current path 
				plt.savefig(figures_dir +"Fig_C" + str(c)+"_S" + str(s) + ".png")

				# Cleaning aux_list to move to the next scenario
				aux_list = []
				plt.close(plt.figure(c+s))

