""""
========================== Summary Results =========================
"""
class SummaryResults: 
	def __init__(self, data, results):
		self.data = data
		self.results = results

	# Function to write results in an txt file
	def WritingUnfeasibleOutputFile(self):
		results = self.results
		output_file = open('output_file.txt','w')
		output_file.write("\n************* START: Summary Results  *************\n")

		# The status of the solution is saved in the output_file
		output_file.write("Status: " + results.Status + "\n")
		output_file.write("\nInfeasible problem! Please revise the input data file and make sure all data is consistent!\n")
		output_file.write("\n************* END: Summary Results  *************\n")

	def WritingFeasibleOutputFile(self, List_TSC, List_TS, List_SC, List_TSCB, List_ATSC):
		data = self.data
		results = self.results
		# save results
		output_file = open('output_file.txt','w')

		output_file.write("\n************* START: Summary Results  *************\n")

		# The status of the solution is printed
		output_file.write("Status: " + results.Status + "\n")

		output_file.write("\n======= Costs ======\n")
		# Show the value of the objective function
		output_file.write("Value of the objective function: " + "\t" + str(round(results.ObjectiveFunctionValue,0)) + "\t" + "R$" + "\n")
		output_file.write("Investment cost: " + "\t" + "\t" + "\t" + str(round(sum([data.cPV[a] * results.MxPPV_alpha[a] for a in data.A]) + sum([data.cESS[b] * (0.4 * results.MxEESS_beta[b] + 0.6 * results.MxPESS_beta[b]) for b in data.B]) + data.cITer * results.MxPTer,0)) + "\t" + "R$\n")
		output_file.write("Operation cost: " + "\t" + "\t" + "\t" + str(round(sum([(1/((1.0 + data.r)**(data.d)) * ((1.0 + data.r)**(data.timeOp) - 1)/(data.r * (1.0 + data.r)**(data.timeOp))) * 365 * data.p[s][c] * data.cEDS[t] * data.deltat * results.PEDS[t][s][c] for (t,s,c) in List_TSC]),0)) + "\t" + "R$\n")
		output_file.write("Thermal generation cost: " + "\t" + "\t"  + str(round(sum([(1/((1.0 + data.r)**(data.d)) * ((1.0 + data.r)**(data.timeOp) - 1)/(data.r * (1.0 + data.r)**(data.timeOp))) * 365 * data.p[s][c] * data.cOTer[t] * data.deltat * results.PTER[t][s][c] for (t,s,c) in List_TSC]),0)) + "\t" + "R$\n")
		output_file.write("Load shedding cost: " + "\t" + "\t" + str(round(sum([(1/((1.0 + data.r)**(data.d)) * ((1.0 + data.r)**(data.timeOp) - 1)/(data.r * (1.0 + data.r)**(data.timeOp))) * 365 * data.p[s][c] * data.M * data.fD[t][s] * data.MxPD * results.xD[t][s][c] * data.deltat for (t,s,c) in List_TSC]),0)) + "\t" + "R$\n")

		# Show results
		output_file.write("\n====== Sizing ======\n")
		output_file.write("Thermal generation size (MxPTer): " + "\t" + str(round(results.MxPTer,0)) + "\t" + "kW\n")
		output_file.write("PV generation size (MxPPV): " + "\t" + "\t" + str(round(results.MxPPV,0)) + "\t" + "kW\n")
		output_file.write("ESS power converter (MxPESS): " + "\t" + str(round(results.MxPESS,0)) + "\t" + "kW\n")
		output_file.write("ESS energy capacity (MxEESS): " + "\t" + str(round(results.MxEESS,0)) + "\t" + "kWh\n")
		for a in data.A:
			if results.alpha[a] != 0: 
				output_file.write("Type of PV technology chosen:" + "\t" + str(data.PV_tech_name[a]) + "\n")
		for b in data.B:
			if results.beta[b] != 0: 
				output_file.write("Type of ESS technology chosen:" + "\t" + str(data.ESS_tech_name[b]) + "\n")

		output_file.write("\n************* END: Summary Results  *************\n")

		output_file.write("\n======= Detailed operation of the Microgrid components  ======\n")
		# Apresenta os resultados da operacao do gerador termico
		output_file.write("\nPTER - Potencia fornecida pela geracao termica:\n")
		output_file.write("c | t\t")
		for t in data.T:
			output_file.write(str(int(t) * data.deltat) + "\t")
		output_file.write("\n")
		for c in data.C:
			output_file.write(c + ":\t")
			for t in data.T:
				output_file.write(str(round(results.PTER[t]['5'][c],2)) + "\t")
			output_file.write("\n")

		# Apresenta os resultados da subestacao
		output_file.write("\nPEDS - Potencia fornecida pela subestacao:\n")
		output_file.write("c | t\t")
		for t in data.T:
			output_file.write(str(int(t) * data.deltat) + "\t")
		output_file.write("\n")
		for c in data.C:
			output_file.write(c + ":\t")
			for t in data.T:
				output_file.write(str(round(results.PEDS[t]['5'][c],2)) + "\t")
			output_file.write("\n")

		# Apresenta os resultados da operacao carga/descarga da bateria
		output_file.write("\nPESS - Potencia carga/descarga da bateria:\n")
		output_file.write("c | t\t")
		for t in data.T:
			output_file.write(str(int(t) * data.deltat) + "\t")
		output_file.write("\n")
		for c in data.C:
			output_file.write(c + ":\t")
			for t in data.T:
				output_file.write(str(round(results.PESS_in[t]['5'][c] - results.PESS_out[t]['5'][c],2)) + "\t")
			output_file.write("\n")

		# Apresenta os resultados da energia armazenada na bateria
		output_file.write("\nEESS - Energia armazenada na bateria:\n")
		output_file.write("c | t\t")
		for t in data.T:
			output_file.write(str(int(t) * data.deltat) + "\t")
		output_file.write("\n")
		for c in data.C:
			output_file.write(c + ":\t")
			for t in data.T:
				output_file.write(str(round(results.EESS[t]['5'][c],2)) + "\t")
			output_file.write("\n")

		# Apresenta os resultados do corte de carga
		output_file.write("\nfD * MxPD * xD - Corte de carga:\n")
		output_file.write("c | t\t")
		for t in data.T:
			output_file.write(str(int(t) * data.deltat) + "\t")
		output_file.write("\n")
		for c in data.C:
			output_file.write(c + ":\t")
			for t in data.T:
				output_file.write(str(round(data.fD[t]['5'] * data.MxPD * results.xD[t]['5'][c],2)) + "\t")
			output_file.write("\n")

		# Apresenta os resultados da geracao fotovoltaica
		output_file.write("\nfPV * MxPPV - Geracao fotovoltaica:\n")
		output_file.write("c | t\t")
		for t in data.T:
			output_file.write(str(int(t) * data.deltat) + "\t")
		output_file.write("\n")
		for c in data.C:
			output_file.write(c + ":\t")
			for t in data.T:
				output_file.write(str(round(sum([data.fPV[t]['5'] * data.eta[a] * results.MxPPV_alpha_xPV[a][t]['5'][c] for a in data.A]),2)) + "\t")
			output_file.write("\n")

		output_file.close()